Index: configure
===================================================================
--- configure	(revision 144)
+++ configure	(working copy)
@@ -1647,7 +1647,7 @@
 
 
 QA_PACKAGE="qmailadmin"
-QA_VERSION="1.2.9"
+QA_VERSION="1.2.10"
 
 
 cat >>confdefs.h <<_ACEOF
Index: qmailadmin.c
===================================================================
--- qmailadmin.c	(revision 144)
+++ qmailadmin.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: qmailadmin.c,v 1.6.2.10 2005/08/10 17:42:49 tomcollins Exp $
+ * $Id: qmailadmin.c,v 1.6.2.11 2006/02/05 17:03:44 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -129,7 +129,7 @@
   pi=getenv("PATH_INFO");
   if ( pi )  pi = strdup(pi);
 
-  if (pi) strcpy (TmpBuf2, pi+5);
+  if (pi) snprintf (TmpBuf2, sizeof(TmpBuf2), "%s", pi + 5);
   rm = getenv("REQUEST_METHOD");
   rm = (rm == NULL ? "" : strdup(rm));
 
Index: util.c
===================================================================
--- util.c	(revision 144)
+++ util.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: util.c,v 1.4.2.6 2005/07/11 06:08:46 tomcollins Exp $
+ * $Id: util.c,v 1.4.2.7 2006/02/05 16:49:08 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -390,6 +390,43 @@
     return 0;
 }
 
+void print_user_index (char *action, int colspan, char *user, char *dom, time_t mytime)
+{
+#ifdef USER_INDEX
+  int k;
+
+  printf ("<tr bgcolor=%s>", get_color_text("000"));
+  printf ("<td colspan=%d align=\"center\">", colspan);
+  printf ("<hr>");
+  printf ("<b>%s</b> &nbsp; ", html_text[133]);
+  for (k = 0; k < 10; k++) {
+	printh ("<a href=\"%s/com/%s?user=%C&dom=%C&time=%d&searchuser=%d\">%d</a>\n",
+	  CGIPATH, action, user, dom, mytime, k, k);
+  }
+  for (k = 'a'; k <= 'z'; k++) {
+	printh ("<a href=\"%s/com/%s?user=%C&dom=%C&time=%d&searchuser=%c\">%c</a>\n",
+	  CGIPATH, action, user, dom, mytime, k, k);
+  }
+  printf ("</td>");
+  printf ("</tr>\n");
+
+  printf ("<tr bgcolor=%s>", get_color_text("000"));
+  printf ("<td colspan=%d>", colspan);
+  printf ("<table border=0 cellpadding=3 cellspacing=0 width=\"100%%\"><tr><td align=\"center\"><br>");
+  printf ("<form method=\"get\" action=\"%s/com/%s\">", CGIPATH, action);
+  printh ("<input type=\"hidden\" name=\"user\" value=\"%H\">", user);
+  printh ("<input type=\"hidden\" name=\"dom\" value=\"%H\">", dom);
+  printf ("<input type=\"hidden\" name=\"time\" value=\"%u\">", (unsigned int) mytime);
+  printh ("<input type=\"text\" name=\"searchuser\" value=\"%H\">&nbsp;", SearchUser);
+  printf ("<input type=\"submit\" value=\"%s\">", html_text[204]);
+  printf ("</form>");
+  printf ("</td></tr></table>");
+  printf ("<hr>");
+  printf ("</td></tr>\n");
+
+#endif
+}
+
 /*
  * Brian Kolaci
  * updated function that doesn't require fts_*
Index: user.c
===================================================================
--- user.c	(revision 144)
+++ user.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: user.c,v 1.11.2.11 2005/01/23 17:35:12 tomcollins Exp $
+ * $Id: user.c,v 1.11.2.13 2006/02/09 05:09:53 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -29,6 +29,7 @@
 #include <dirent.h>
 #include <errno.h>
 #include <vpopmail_config.h>
+#include "vpopmail.h"
 /* undef some macros that get redefined in config.h below */
 #undef PACKAGE_NAME  
 #undef PACKAGE_STRING 
@@ -45,7 +46,6 @@
 #include "template.h"
 #include "user.h"
 #include "util.h"
-#include "vpopmail.h"
 #include "vauth.h"
 
 
@@ -244,40 +244,9 @@
     }
 
     if (AdminType == DOMAIN_ADMIN) {
-#ifdef USER_INDEX
-      printf ("<tr bgcolor=%s>", get_color_text("000"));
-      printf ("<td colspan=\"%i\" align=\"center\">", colspan);
-      printf ("<hr>");
-      printf ("<b>%s</b>", html_text[133]);
-      printf ("<br>");
-      for (k = 'a'; k <= 'z'; k++) {
-        printh ("<a href=\"%s/com/showusers?user=%C&dom=%C&time=%d&searchuser=%c\">%c</a>\n",
-          CGIPATH,user,dom,mytime,k,k);
-      }
-      printf ("<br>");
-      for (k = 0; k < 10; k++) {
-        printh ("<a href=\"%s/com/showusers?user=%C&dom=%C&time=%d&searchuser=%d\">%d</a>\n",
-          CGIPATH,user,dom,mytime,k,k);
-      }
-      printf ("</td>");
-      printf ("</tr>\n");
+      print_user_index ("showusers", colspan, user, dom, mytime);
 
       printf ("<tr bgcolor=%s>", get_color_text("000"));
-      printf ("<td colspan=%i>", colspan);
-      printf ("<table border=0 cellpadding=3 cellspacing=0 width=\"100%%\"><tr><td align=\"center\"><br>");
-      printf ("<form method=\"get\" action=\"%s/com/showusers\">", CGIPATH);
-      printh ("<input type=\"hidden\" name=\"user\" value=\"%H\">", user);
-      printh ("<input type=\"hidden\" name=\"dom\" value=\"%H\">", dom);
-      printf ("<input type=\"hidden\" name=\"time\" value=\"%u\">", (unsigned int) mytime);
-      printh ("<input type=\"text\" name=\"searchuser\" value=\"%H\">&nbsp;", SearchUser);
-      printf ("<input type=\"submit\" value=\"%s\">", html_text[204]);
-      printf ("</form>");
-      printf ("</td></tr></table>");
-      printf ("<hr>");
-      printf ("</td></tr>\n");
-#endif
-
-      printf ("<tr bgcolor=%s>", get_color_text("000"));
       printf ("<td colspan=\"%i\" align=\"right\">", colspan);
 #ifdef USER_INDEX
       printf ("<font size=\"2\"><b>");
Index: BUGS
===================================================================
--- BUGS	(revision 144)
+++ BUGS	(working copy)
@@ -1,4 +1,4 @@
-* QmailAdmin rewrites a users .qmail file whenver changes are made on the 
+* QmailAdmin rewrites a user's .qmail file whenever changes are made on the 
   modify user screen.  The code currently doesn't handle .qmail files that
-  were hand modified or generated elsewhere (e.g., TMDA).
+  were hand-modified or generated elsewhere (e.g. by TMDA).
 
Index: qmailadmin.h
===================================================================
--- qmailadmin.h	(revision 144)
+++ qmailadmin.h	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: qmailadmin.h,v 1.1.1.1.2.5 2005/01/23 17:35:12 tomcollins Exp $
+ * $Id: qmailadmin.h,v 1.1.1.1.2.6 2006/02/05 17:07:27 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -36,6 +36,9 @@
 
 #define MAX_FILE_NAME 100
 
+#ifdef MAX_BUFF
+#undef MAX_BUFF
+#endif
 #define MAX_BUFF 500
 #define MAX_BIG_BUFF 5000
 
Index: util.h
===================================================================
--- util.h	(revision 144)
+++ util.h	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: util.h,v 1.1.2.1 2004/11/20 01:10:41 tomcollins Exp $
+ * $Id: util.h,v 1.1.2.2 2006/02/05 16:49:08 tomcollins Exp $
  */
 
 int check_local_user( char *user );
@@ -27,3 +27,5 @@
 
 int quota_to_bytes(char[], char*);     //jhopper prototype
 int quota_to_megabytes(char[], char*); //jhopper prototype
+
+void print_user_index (char *action, int colspan, char *user, char *dom, time_t mytime);
Index: TRANSLATORS
===================================================================
--- TRANSLATORS	(revision 144)
+++ TRANSLATORS	(working copy)
@@ -3,6 +3,7 @@
 
 Recent Translators:
 bg	Bulgarian	Julian Neytchev <jneytchev@cox.net>
+bg	Bulgarian	Peter Pentchev <roamer@users.sf.net>
 cs	Czech		Martin Dimov <dimov@strih.cz>
 da	Danish		Martin Dalum <garfield-qmailadmin@webz.dk>
 da	Danish		Jesper Have <webmaster@jdh.dk>
Index: lang/bg
===================================================================
--- lang/bg	(revision 144)
+++ lang/bg	(working copy)
@@ -106,7 +106,7 @@
 138  
 139        
 140      .
-141    
+141    
 142   
 143       
 144       
@@ -119,37 +119,37 @@
 151    
 152    
 153   
-154    
+154    
 155  
-156     
-157      
-158      
+156     
+157      
+158      
 159  DotQmail Type: adddotqmail()
 160  
-161      .      
+161      .     .
 162     
 163    
 164   Type : adddotqmailnow()
 165        
-166       
+166       
 167       /   .
-168 /      .
+168 /      .
 169          
 170       
 171 :     
 172           .         .
-173   ,    
+173   ,    
 174     
 175    
 176      
 177     
 178   
 179     
-180     
+180     
 181      
-182     
-183     
-184      
+182     
+183     
+184      
 185     
 186     
 187     
@@ -158,13 +158,13 @@
 190   
 191        
 192     
-193    
-194         
+193    
+194         
 195     
 196     
 197      
 198   
-199      
+199      
 200   ,  
 201   
 202    :
@@ -188,10 +188,10 @@
 220   
 221   
 222   
-223    
+223    
 224 (  )
 225   
-226     
+226     
 227 
 228  :
 229 
@@ -200,12 +200,12 @@
 232  /  
 233     
 234   
-235     
+235     
 236 : 
 237 <br>  
 238 <br>  
 239 <br>  
-240           
+240           
 241       
 242      
 243      
@@ -233,13 +233,13 @@
 265       ,         .
 266      ,     .
 267       ,         .
-268  
+268   
 269       <B>[%s]</B>.
 270     
 271     .
 272  %s-.
 273     %s-.
-274  %s- , %s-     ..        %s-.
+274  %s-subscribe ( ), %s-unsubscribe (   )  ..,        %s-request ().
 275  
 276       
 277    -   
@@ -253,11 +253,11 @@
 285               
 286    .
 287       :
-288 :               .
+288 :         ,      .
 289  
 290    
 291        ezmlm-cgi.
-292    
+292    
 293   
 294    
 295    
@@ -273,11 +273,13 @@
 305 
 306  
 307  
-308   
-309   %s 
+308   
+309   %s 
 310     
 311  
 312  
 313  
 314    
 315   .       '%s'.
+316  
+317      postmaster.
Index: auth.c
===================================================================
--- auth.c	(revision 144)
+++ auth.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: auth.c,v 1.3.2.5 2005/01/23 17:35:11 tomcollins Exp $
+ * $Id: auth.c,v 1.3.2.6 2006/02/09 05:09:53 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -26,9 +26,9 @@
 #include <pwd.h>
 #include <dirent.h>
 #include "config.h"
+#include <vpopmail.h>
 #include "qmailadmin.h"
 #include "qmailadminx.h"
-#include <vpopmail.h>
 #include <vauth.h>
 #include "cgi.h"
 #include "show.h"
Index: configure.in
===================================================================
--- configure.in	(revision 144)
+++ configure.in	(working copy)
@@ -6,7 +6,7 @@
 AC_CANONICAL_HOST
 
 QA_PACKAGE="qmailadmin"
-QA_VERSION="1.2.9"
+QA_VERSION="1.2.10"
 
 AC_DEFINE_UNQUOTED(QA_PACKAGE,"$QA_PACKAGE","")
 AC_DEFINE_UNQUOTED(QA_VERSION,"$QA_VERSION","")
Index: ChangeLog
===================================================================
--- ChangeLog	(revision 144)
+++ ChangeLog	(working copy)
@@ -1,6 +1,24 @@
 Numbers in square brackets ([]) indicate tracker item on SourceForge with 
 patch or information related to the entry.
 
+1.2.10 - unreleased
+
+	Peter Pentchev
+	- Update Bulgarian translation. [1421770]
+	- qmailadmin.c: Fix potential buffer overflow.
+	- alias.c: missing semicolon when using VALIAS, eliminate unused
+	  variable warnings when using VALIAS.
+
+	Tom Collins
+	- mailinglist.c: Fix problem with enable/disable ezmlm-cgi access
+	  to archives.
+	- alias.c: Add index and user search to the aliases page.  When
+	  deleting an alias, return to the page that alias would have been
+	  on.  This feature was sponsored by Marko Lerota. [894823, 877895]
+	- qmailadmin.h: undef MAX_BUFF if previously defined (too small) by 
+	  vpopmail.h.  Include vpopmail.h before qmailadmin.h so we can
+	  always redefine MAX_BUFF.
+
 1.2.9 - released 1-Sep-05
 
 	Luis Gonzalo Constantini Von Rickel
Index: mailinglist.c
===================================================================
--- mailinglist.c	(revision 144)
+++ mailinglist.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: mailinglist.c,v 1.5.2.7 2005/02/16 16:10:37 tomcollins Exp $
+ * $Id: mailinglist.c,v 1.5.2.8 2005/10/23 18:52:34 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -1307,7 +1307,7 @@
   printf ("<BR>\n");
   /* note that if user doesn't have ezmlm-cgi installed, it might be
      a good idea to default to having option i off. */
-  build_option_str ("CHECKBOX", "opt15", "i", html_text[291]);
+  build_option_str ("CHECKBOX", "opt16", "i", html_text[291]);
   printf ("</P>\n");
 
   /***********************/
Index: command.c
===================================================================
--- command.c	(revision 144)
+++ command.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: command.c,v 1.2.2.6 2005/01/23 17:35:11 tomcollins Exp $
+ * $Id: command.c,v 1.2.2.7 2006/02/05 16:49:08 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -83,6 +83,7 @@
 
   } else if (strcmp(TmpBuf2, "showforwards") == 0) {
     GetValue(TmpCGI, Pagenumber, "page=", sizeof(Pagenumber));
+    GetValue(TmpCGI, SearchUser, "searchuser=", sizeof(SearchUser));
     show_forwards(Username, Domain, Mytime);
 
   } else if (strcmp(TmpBuf2, "showmailinglists") == 0) {
Index: alias.c
===================================================================
--- alias.c	(revision 144)
+++ alias.c	(working copy)
@@ -1,5 +1,5 @@
 /* 
- * $Id: alias.c,v 1.4.2.12 2005/01/23 17:35:11 tomcollins Exp $
+ * $Id: alias.c,v 1.4.2.14 2006/02/09 05:02:55 tomcollins Exp $
  * Copyright (C) 1999-2004 Inter7 Internet Technologies, Inc. 
  *
  * This program is free software; you can redistribute it and/or modify
@@ -103,22 +103,23 @@
 void show_dotqmail_lines(char *user, char *dom, time_t mytime)
 {
  int moreusers=0;
- DIR *mydir;
- struct dirent *mydirent;
- FILE *fs;
  char alias_user[MAX_BUFF];
  char alias_name[MAX_FILE_NAME];
  char *alias_domain;
  char *alias_name_from_command;
- int i,j,stop,k,startnumber;
- int m,n;
+ int stop,k,startnumber;
  int page;
- struct dirent **namelist;
  char this_alias[MAX_FILE_NAME];
 #ifdef VALIAS
  char *alias_line;
+#else
+ DIR *mydir;
+ struct dirent *mydirent;
+ FILE *fs;
+ int i,j,m,n;
+ struct dirent **namelist;
+ struct stat sbuf;
 #endif
- struct stat sbuf;
 
   if ( AdminType!=DOMAIN_ADMIN ) {
     snprintf(StatusMessage, sizeof(StatusMessage), "%s", html_text[142]);
@@ -130,9 +131,28 @@
   if (page == 0) page = 1;
 
   startnumber = MAXALIASESPERPAGE * (page - 1);
-  k=0;
+  k = 0;
+  
+#ifdef VALIAS
+  if (*SearchUser) {
+    startnumber = 0;
+    alias_line = valias_select_all(alias_name, Domain);
+    while (alias_line != NULL) {
+      strcpy (this_alias, alias_name);
+      alias_name_from_command = dotqmail_alias_command(alias_line);
+      if ( alias_name_from_command != NULL || *alias_line == '#') {
+        if (strcasecmp (SearchUser, alias_name) <= 0) break;
+        startnumber++;
+      }      
+      /* burn through remaining lines for this alias, if necessary */
+      while ((alias_line != NULL) && (strcmp (this_alias, alias_name) == 0)) {
+        alias_line = valias_select_all_next(alias_name);
+      }
+    }
+    page = startnumber / MAXALIASESPERPAGE + 1;
+    sprintf (Pagenumber, "%d", page);
+  }
 
-#ifdef VALIAS
   alias_line = valias_select_all(alias_name, Domain);
   while (alias_line != NULL) {
     strcpy (this_alias, alias_name);
@@ -174,6 +194,7 @@
     }
   }
 #else
+
   /* We can't use valias code here, because it doesn't return a sorted
      list of aliases.  If we update vpopmail's vpalias.c to do that,
      then qmailadmin could use the single set of valias_ functions above.
@@ -216,15 +237,32 @@
       if ( alias_name_from_command != NULL || *TmpBuf2 == '#') {
         k++;
       
-        if ( k >MAXALIASESPERPAGE + startnumber) {
-          moreusers=1;
-          fclose(fs);
-          break;
+        if (*SearchUser) {
+          if (strcasecmp (SearchUser, alias_name) <= 0) {
+            if (startnumber == 0) {
+              startnumber = k;
+              page = (k/MAXALIASESPERPAGE)+1;
+            }
+            if (k >= MAXALIASESPERPAGE + startnumber) {
+              moreusers = 1;
+              fclose (fs);
+              break;
+            }
+          } else {
+            fclose (fs);
+            continue;
+          }
+        } else {
+          if ( k >MAXALIASESPERPAGE + startnumber) {
+            moreusers=1;
+            fclose(fs);
+            break;
+          }
+          if (k <= startnumber) {
+            fclose (fs);
+            continue;
+          }
         }
-        if (k <= startnumber) {
-          fclose (fs);
-          continue;
-        }
 
         if (*TmpBuf2 == '#') {
           if (fgets(TmpBuf2, sizeof(TmpBuf2), fs) == NULL) {
@@ -252,6 +290,10 @@
   /* free memory allocated by bkscandir */
   for (m=0; m<n; m++) free(namelist[m]);
   free(namelist);
+  
+  if (*SearchUser && (startnumber == 0)) {
+  	page = (k/MAXALIASESPERPAGE)+1;
+  }
 #endif
 
   curalias = firstalias;
@@ -321,21 +363,37 @@
   }
 
   if (AdminType == DOMAIN_ADMIN) {
+
+    print_user_index ("showforwards", 4, user, dom, mytime);
+    
     printf ("<tr><td align=\"right\" colspan=\"4\">");
     printf ("[&nbsp;");
-    if(page > 1 ) {
+	/* When searching for a user on systems using .qmail files, we make things
+	 * easy by starting the page with the first matching address.  As a result,
+	 * the previous page will be 'page' and not 'page-1'.  Refresh is accomplished
+	 * by repeating the search.
+	 */
+    if (*SearchUser && ((startnumber % MAXALIASESPERPAGE) != 1)) {
       printh ("<a href=\"%s/com/showforwards?user=%C&dom=%C&time=%d&page=%d\">%s</a>",
-        CGIPATH,user,dom,mytime,page - 1, html_text[135]);
+        CGIPATH, user, dom, mytime, page, html_text[135]);
       printf ("&nbsp;|&nbsp;");
+      printh ("<a href=\"%s/com/showforwards?user=%C&dom=%C&time=%d&searchuser=%C\">%s</a>",
+        CGIPATH, user, dom, mytime, SearchUser, html_text[136]);
+    } else {
+      if (page > 1) {
+        printh ("<a href=\"%s/com/showforwards?user=%C&dom=%C&time=%d&page=%d\">%s</a>",
+          CGIPATH, user, dom, mytime, page - 1, html_text[135]);
+        printf ("&nbsp;|&nbsp;");
+      }
+      printh ("<a href=\"%s/com/showforwards?user=%C&dom=%C&time=%d&page=%d\">%s</a>",
+        CGIPATH, user, dom, mytime, page, html_text[136]);
     }
-    printh ("<a href=\"%s/com/showforwards?user=%C&dom=%C&time=%d&page=%d\">%s</a>",
-      CGIPATH,user,dom,mytime,page, html_text[136]);
-    printf ("&nbsp;|&nbsp;");
     if (moreusers) {
+      printf ("&nbsp;|&nbsp;");
       printh ("<a href=\"%s/com/showforwards?user=%C&dom=%C&time=%d&page=%d\">%s</a>",
-        CGIPATH,user,dom,mytime,page+1, html_text[137]);    
-      printf ("&nbsp;]");
+        CGIPATH, user, dom, mytime, page + 1, html_text[137]);    
     }
+    printf ("&nbsp;]");
     printf ("</td></tr>");                                    
   }
 }
@@ -638,6 +696,7 @@
   if(CurForwards == 0 && CurBlackholes == 0) {
     show_menu(Username, Domain, Mytime);
   } else {
+  	snprintf (SearchUser, sizeof(SearchUser), "%s", ActionUser);
     show_forwards(Username,Domain,Mytime);
   }
 }
Index: aclocal.m4
===================================================================
--- aclocal.m4	(revision 144)
+++ aclocal.m4	(working copy)
@@ -834,7 +834,16 @@
 [AC_FOREACH([_AM_File], [$1], [_AM_CONFIG_HEADER(_AM_File, [$2], [$3])])
 ])# AM_CONFIG_HEADER
 
-#serial 1
+# isc-posix.m4 serial 2 (gettext-0.11.2)
+dnl Copyright (C) 1995-2002 Free Software Foundation, Inc.
+dnl This file is free software, distributed under the terms of the GNU
+dnl General Public License.  As a special exception to the GNU General
+dnl Public License, this file may be distributed as part of a program
+dnl that contains a configuration script generated by Autoconf, under
+dnl the same distribution terms as the rest of that program.
+
+# This file is not needed with autoconf-2.53 and newer.  Remove it in 2005.
+
 # This test replaces the one in autoconf.
 # Currently this macro should have the same name as the autoconf macro
 # because gettext's gettext.m4 (distributed in the automake package)
